<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>MultiTransactionRecord.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">MultiTransactionRecord.java</span></div><h1>MultiTransactionRecord.java</h1><pre class="source lang-java linenums">/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the &quot;License&quot;); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

import org.apache.jute.InputArchive;
import org.apache.jute.OutputArchive;
import org.apache.jute.Record;
import org.apache.zookeeper.proto.*;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Encodes a composite transaction.  In the wire format, each transaction
 * consists of a single MultiHeader followed by the appropriate request.
 * Each of these MultiHeaders has a type which indicates
 * the type of the following transaction or a negative number if no more transactions
 * are included.
 */
public class MultiTransactionRecord implements Record, Iterable&lt;Op&gt; {
<span class="fc" id="L38">    private List&lt;Op&gt; ops = new ArrayList&lt;Op&gt;();</span>

<span class="fc" id="L40">    public MultiTransactionRecord() {</span>
<span class="fc" id="L41">    }</span>

<span class="fc" id="L43">    public MultiTransactionRecord(Iterable&lt;Op&gt; ops) {</span>
<span class="fc bfc" id="L44" title="All 2 branches covered.">        for (Op op : ops) {</span>
<span class="fc" id="L45">            add(op);</span>
<span class="fc" id="L46">        }</span>
<span class="fc" id="L47">    }</span>

    @Override
    public Iterator&lt;Op&gt; iterator() {
<span class="fc" id="L51">        return ops.iterator() ;</span>
    }

    public void add(Op op) {
<span class="fc" id="L55">        ops.add(op);</span>
<span class="fc" id="L56">    }</span>

    public int size() {
<span class="nc" id="L59">        return ops.size();</span>
    }

    @Override
    public void serialize(OutputArchive archive, String tag) throws IOException {
<span class="fc" id="L64">        archive.startRecord(this, tag);</span>
<span class="fc" id="L65">        int index = 0 ;</span>
<span class="fc bfc" id="L66" title="All 2 branches covered.">        for (Op op : ops) {</span>
<span class="fc" id="L67">            MultiHeader h = new MultiHeader(op.getType(), false, -1);</span>
<span class="fc" id="L68">            h.serialize(archive, tag);</span>
<span class="pc bpc" id="L69" title="1 of 5 branches missed.">            switch (op.getType()) {</span>
               case ZooDefs.OpCode.create:
<span class="fc" id="L71">                    op.toRequestRecord().serialize(archive, tag);</span>
<span class="fc" id="L72">                    break;</span>
                case ZooDefs.OpCode.delete:
<span class="fc" id="L74">                    op.toRequestRecord().serialize(archive, tag);</span>
<span class="fc" id="L75">                    break;</span>
                case ZooDefs.OpCode.setData:
<span class="fc" id="L77">                    op.toRequestRecord().serialize(archive, tag);</span>
<span class="fc" id="L78">                    break;</span>
                case ZooDefs.OpCode.check:
<span class="fc" id="L80">                    op.toRequestRecord().serialize(archive, tag);</span>
<span class="fc" id="L81">                    break;</span>
                default:
<span class="nc" id="L83">                    throw new IOException(&quot;Invalid type of op&quot;);</span>
            }
<span class="fc" id="L85">        }</span>
<span class="fc" id="L86">        new MultiHeader(-1, true, -1).serialize(archive, tag);</span>
<span class="fc" id="L87">        archive.endRecord(this, tag);</span>
<span class="fc" id="L88">    }</span>

    @Override
    public void deserialize(InputArchive archive, String tag) throws IOException {
<span class="fc" id="L92">        archive.startRecord(tag);</span>
<span class="fc" id="L93">        MultiHeader h = new MultiHeader();</span>
<span class="fc" id="L94">        h.deserialize(archive, tag);</span>

<span class="fc bfc" id="L96" title="All 2 branches covered.">        while (!h.getDone()) {</span>
<span class="pc bpc" id="L97" title="1 of 5 branches missed.">            switch (h.getType()) {</span>
               case ZooDefs.OpCode.create:
<span class="fc" id="L99">                    CreateRequest cr = new CreateRequest();</span>
<span class="fc" id="L100">                    cr.deserialize(archive, tag);</span>
<span class="fc" id="L101">                    add(Op.create(cr.getPath(), cr.getData(), cr.getAcl(), cr.getFlags()));</span>
<span class="fc" id="L102">                    break;</span>
                case ZooDefs.OpCode.delete:
<span class="fc" id="L104">                    DeleteRequest dr = new DeleteRequest();</span>
<span class="fc" id="L105">                    dr.deserialize(archive, tag);</span>
<span class="fc" id="L106">                    add(Op.delete(dr.getPath(), dr.getVersion()));</span>
<span class="fc" id="L107">                    break;</span>
                case ZooDefs.OpCode.setData:
<span class="fc" id="L109">                    SetDataRequest sdr = new SetDataRequest();</span>
<span class="fc" id="L110">                    sdr.deserialize(archive, tag);</span>
<span class="fc" id="L111">                    add(Op.setData(sdr.getPath(), sdr.getData(), sdr.getVersion()));</span>
<span class="fc" id="L112">                    break;</span>
                case ZooDefs.OpCode.check:
<span class="fc" id="L114">                    CheckVersionRequest cvr = new CheckVersionRequest();</span>
<span class="fc" id="L115">                    cvr.deserialize(archive, tag);</span>
<span class="fc" id="L116">                    add(Op.check(cvr.getPath(), cvr.getVersion()));</span>
<span class="fc" id="L117">                    break;</span>
                default:
<span class="nc" id="L119">                    throw new IOException(&quot;Invalid type of op&quot;);</span>
            }
<span class="fc" id="L121">            h.deserialize(archive, tag);</span>
        }
<span class="fc" id="L123">        archive.endRecord(tag);</span>
<span class="fc" id="L124">    }</span>

    @Override
    public boolean equals(Object o) {
<span class="pc bpc" id="L128" title="1 of 2 branches missed.">        if (this == o) return true;</span>
<span class="pc bpc" id="L129" title="1 of 2 branches missed.">        if (!(o instanceof MultiTransactionRecord)) return false;</span>

<span class="fc" id="L131">        MultiTransactionRecord that = (MultiTransactionRecord) o;</span>

<span class="pc bpc" id="L133" title="1 of 2 branches missed.">        if (ops != null) {</span>
<span class="fc" id="L134">            Iterator&lt;Op&gt; other = that.ops.iterator();</span>
<span class="fc bfc" id="L135" title="All 2 branches covered.">            for (Op op : ops) {</span>
<span class="fc" id="L136">                boolean hasMoreData = other.hasNext();</span>
<span class="pc bpc" id="L137" title="1 of 2 branches missed.">                if (!hasMoreData) {</span>
<span class="nc" id="L138">                    return false;</span>
                }
<span class="fc" id="L140">                Op otherOp = other.next();</span>
<span class="pc bpc" id="L141" title="1 of 2 branches missed.">                if (!op.equals(otherOp)) {</span>
<span class="nc" id="L142">                    return false;</span>
                }
<span class="fc" id="L144">            }</span>
<span class="pc bpc" id="L145" title="1 of 2 branches missed.">            return !other.hasNext();</span>
        } else {
<span class="nc bnc" id="L147" title="All 2 branches missed.">            return that.ops == null;</span>
        }

    }

    @Override
    public int hashCode() {
<span class="fc" id="L154">        int h = 1023;</span>
<span class="fc bfc" id="L155" title="All 2 branches covered.">        for (Op op : ops) {</span>
<span class="fc" id="L156">            h = h * 25 + op.hashCode();</span>
<span class="fc" id="L157">        }</span>
<span class="fc" id="L158">        return h;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>